// Code generated by go-swagger; DO NOT EDIT.

package generic_project_file

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "gitlab.com/pear-slices/mobile_platform/bitrise-step-api-build-trigger/models"
)

// NewGenericProjectFilesCreateParams creates a new GenericProjectFilesCreateParams object
// with the default values initialized.
func NewGenericProjectFilesCreateParams() *GenericProjectFilesCreateParams {
	var ()
	return &GenericProjectFilesCreateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGenericProjectFilesCreateParamsWithTimeout creates a new GenericProjectFilesCreateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGenericProjectFilesCreateParamsWithTimeout(timeout time.Duration) *GenericProjectFilesCreateParams {
	var ()
	return &GenericProjectFilesCreateParams{

		timeout: timeout,
	}
}

// NewGenericProjectFilesCreateParamsWithContext creates a new GenericProjectFilesCreateParams object
// with the default values initialized, and the ability to set a context for a request
func NewGenericProjectFilesCreateParamsWithContext(ctx context.Context) *GenericProjectFilesCreateParams {
	var ()
	return &GenericProjectFilesCreateParams{

		Context: ctx,
	}
}

// NewGenericProjectFilesCreateParamsWithHTTPClient creates a new GenericProjectFilesCreateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGenericProjectFilesCreateParamsWithHTTPClient(client *http.Client) *GenericProjectFilesCreateParams {
	var ()
	return &GenericProjectFilesCreateParams{
		HTTPClient: client,
	}
}

/*GenericProjectFilesCreateParams contains all the parameters to send to the API endpoint
for the generic project files create operation typically these are written to a http.Request
*/
type GenericProjectFilesCreateParams struct {

	/*AppSlug
	  App slug

	*/
	AppSlug string
	/*GenericProjectFile
	  Generic project file parameters

	*/
	GenericProjectFile *models.V0ProjectFileStorageUploadParams

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the generic project files create params
func (o *GenericProjectFilesCreateParams) WithTimeout(timeout time.Duration) *GenericProjectFilesCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the generic project files create params
func (o *GenericProjectFilesCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the generic project files create params
func (o *GenericProjectFilesCreateParams) WithContext(ctx context.Context) *GenericProjectFilesCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the generic project files create params
func (o *GenericProjectFilesCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the generic project files create params
func (o *GenericProjectFilesCreateParams) WithHTTPClient(client *http.Client) *GenericProjectFilesCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the generic project files create params
func (o *GenericProjectFilesCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAppSlug adds the appSlug to the generic project files create params
func (o *GenericProjectFilesCreateParams) WithAppSlug(appSlug string) *GenericProjectFilesCreateParams {
	o.SetAppSlug(appSlug)
	return o
}

// SetAppSlug adds the appSlug to the generic project files create params
func (o *GenericProjectFilesCreateParams) SetAppSlug(appSlug string) {
	o.AppSlug = appSlug
}

// WithGenericProjectFile adds the genericProjectFile to the generic project files create params
func (o *GenericProjectFilesCreateParams) WithGenericProjectFile(genericProjectFile *models.V0ProjectFileStorageUploadParams) *GenericProjectFilesCreateParams {
	o.SetGenericProjectFile(genericProjectFile)
	return o
}

// SetGenericProjectFile adds the genericProjectFile to the generic project files create params
func (o *GenericProjectFilesCreateParams) SetGenericProjectFile(genericProjectFile *models.V0ProjectFileStorageUploadParams) {
	o.GenericProjectFile = genericProjectFile
}

// WriteToRequest writes these params to a swagger request
func (o *GenericProjectFilesCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param app-slug
	if err := r.SetPathParam("app-slug", o.AppSlug); err != nil {
		return err
	}

	if o.GenericProjectFile != nil {
		if err := r.SetBodyParam(o.GenericProjectFile); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
